/*
 * Universidade Federal de Pernambuco - UFPE
 * Centro de Informtica - CIn
 * Centro Integrado de Tecnologia da Informao - CITi
 * Curso de C/C++
 * Autor: Allan Lima - http://allanlima.wordpress.com/
 * Instrutor: Luiz Felipe Sotero (lfss@cin.ufpe.br)
 *
 * exmeploClassesAbstratas.cpp - Mostra implementar classes abstratas em C++
 */

#include <iostream>

using namespace std;

class Poligono {

protected:

    int altura;
    int largura;

public:

    Poligono(int altura, int largura) {
        this->altura = altura;
        this->largura = largura;
    }

    // torna Poligono uma classe Abstrata
    virtual float area() = 0;

    bool isMaior(Poligono &p) {
		// O mtodo rea pode ser chamado mesmo antes de ser implementado
        return this->area() > p.area();
    }
};

class Retangulo : public Poligono {

public:

    Retangulo(int altura, int largura)
        : Poligono(altura,  largura) {
		// chama o construtor da super classe (Poligono)
    }

    float area() {
        return (float) this->altura * this->largura;
    }
};

class Triangulo : public Poligono {

public:

    Triangulo(int altura, int largura)
        : Poligono(altura,  largura) {
		// chama o construtor da super classe (Poligono)
    }


    float area() {
        return (float) (this->altura * this->largura) / 2;
    }
};

int main() {
    Retangulo r(10, 51);
    Triangulo t(45, 10);
    //Poligono p(10, 10); daria um erro de compilao
    Poligono *pp = &r;

    cout << "Area de r: " << r.area() << endl;
    cout << "Area de t: " << t.area() << endl;
    cout << "Area de pp: " << pp->area() << endl;

    pp = &t;
    cout << "Area de pp: " << pp->area() << endl;

    cout << "r > t ? " << r.isMaior(t) << endl;
    cout << "t > r ? " << t.isMaior(r) << endl;

    return 0;
}
